'use strict';

/**
 * This number (in ms) needs to be higher than however long it takes to
 * hide any display generated by the `messagesList` directive.
 * @type {number}
 */
var DEFAULT_HIDE_DELAY = 900;

/**
 * Default level and descriptions
 * @type {Array.<Object.<string, string>>}
 */
var DEFAULT_LEVELS = [
  {
    name: 'ok',
    description: 'Fixed!'
  },
  {
    name: 'warning',
    description: 'Warning'
  },
  {
    name: 'error',
    description: 'Error'
  }
];

/**
 * Default web server path to JSON message definition file
 * @type {string}
 */
var DEFAULT_DATA_FILE = 'messages.json';

/**
 * The default level
 * @type {string}
 */
var DEFAULT_LEVEL = 'ok';

module.exports = {
  levels: DEFAULT_LEVELS,
  defaultLevel: DEFAULT_LEVEL,
  dataFile: DEFAULT_DATA_FILE,
  hideDelay: DEFAULT_HIDE_DELAY,
  templateUrl: 'partials/messages.html'
};

